//  ChainJoiner.h
//  KnightsAndSpies


#import <Foundation/Foundation.h>
#import "TaggedChain.h"

@interface ChainJoiner : NSObject {
    NSMutableArray* allChains;
}

-(ChainJoiner*) initWithAllChains: (NSMutableArray*) givenChains;
-(NSMutableArray*) joinChains;
//takes an array of arrays of chains as produced by ChainBuilder
//then working from the end back, joins initial parts of chains
//so for instance, if sent
//[(1,2,3)S w1, (4,5,6)S w2], [(2,5)K w3] 
//would return
//[(1,2,3)S w1, (4,5,6)S w2], [(1,2,5)K w3]
//Thus no information about earlier chains is lost and weights
//are preserved.
//The change is that we can work with longer chains at the end.
//This should lead to a more efficient approach.

@end
