//
//  HybridInterrogator.m
//  KnightsAndSpies
//
//  Created by Mark Wildon on 02/02/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "HybridInterrogator.h"


@implementation HybridInterrogator

-(HybridInterrogator*) initWithCrowdHybrid: (Crowd*) givenCrowd
{
    self = [super init];
    crowd = givenCrowd; //Not copied
                        //NSLog(@"initWithCrowd here, just set weights = %@",weights);
                        //NSLog(@"crowd = %@",crowd);[crowd showMembers];
    return self;
}

-(NSMutableArray *) buildHybridSpidersAcceptedAt: (int) l {
	NSMutableArray* hybridSpiders = [[NSMutableArray alloc] init];
	int n = [crowd numberOfPeople];
    
	
    //NSLog(@"First phase");
    int m; //m keeps track of the person we're asking about
    int r=0; //r is the next person to put into a chain

	BOOL foundKnight = FALSE;

    while (foundKnight == FALSE)
    {
        m = r; r= r+1;
        //NSLog(@"Starting a new search for a knight, m = %i, r = %i",m,r);
        int votesfor = 1; //the person will vote for themselves (if asked), we assume
        int votesagainst = 0;
        HybridSpider* hybridSpider = [[HybridSpider alloc] initWithPerson: m];
        [hybridSpiders addObject: hybridSpider];

	}
	
}


@end
