//
//  HybridSpider.h
//  KnightsAndSpies
//
//  Created by Mark Wildon on 02/02/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "TaggedChain.h"

@interface HybridSpider : NSObject {
	int person; //person at the centre of the spider
	NSMutableArray* supportiveChains; //array of chains of supporters
	NSMutableArray* accusingChains; //array of chains of accusers
}

-(HybridSpider*) initWithPerson: (int) givenPerson;
-(int) person;
-(NSMutableArray*) supportiveChains;
-(NSMutableArray*) accusingChains;

-(void) addChainFor: (TaggedChain*) chain;
-(void) addChainAgainst: (TaggedChain*) chain; 

@end
