//  Interrogator.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>
#import "ChainBuilderMW.h"
#import "ChainBuilderDW.h"
#import "ChainJoiner.h"
#import "ChainResolver.h"
#import "TaggedChain.h"
#import "Crowd.h"
#import "Person.h"

//extern int MWCB;
//extern int DWCB;

@interface Interrogator : NSObject {
    Crowd* crowd;
    int cb;
    int cr;
}

-(Interrogator*) initWithCrowd: (Crowd*) crowd;
-(void) setChainBuilder: (int) givencb setChainResolver: (int) givencr;
//here cb and cr should take the values define in globalVars.c
-(NSDictionary*) determineIdentitiesAcceptingAt: (int) l;
//returns identities, and also questionsToKnight, i.e. #questions it took to identify the finalKnight
@end
