//  Person.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>

extern int KNIGHT;
extern int SPY;

@interface Person : NSObject {
    int	number; // They have their numbers on their T-shirts. These numbers
                // should agree with their indices in the crowd.
    int weight; // Number of people who have vouched for them
    NSMutableArray* views;
    NSMutableArray* questionsAsked;
}

// Methods defined in person.m
-(Person *) initWithNumber: (int) i;
-(void) setViews: (NSMutableArray *) givenViews;

//-(int) weight;
//-(void) setWeight: (int) w;

-(int) number;
-(NSNumber*) viewOnPerson: (int) i;
-(NSMutableArray*) questionsAsked;
-(int) numberOfQuestionsAsked;
-(BOOL) askedTwiceAboutSamePerson;

-(void) showNumber;
-(void) showViews;
-(void) showViewsAbbreviatedly;
-(void) showQuestionsAsked;

-(void) resetQuestionsAsked;

-(BOOL) isKnight;
-(BOOL) isSpy;

@end
