//  Tester.h
//  KnightsAndSpies


#import <Foundation/Foundation.h>
#import "SpiderInterrogator.h"
#import "Interrogator.h"
#import "Crowd.h"

extern int KNIGHT;
extern int SPY;
extern int RANDOM;
extern int REVERSE;
extern int TRUTH;
extern int REVERSEORSPY;

@interface Tester : NSObject {
}
-(NSDictionary*) singleTestWithCrowd: (Crowd*) crowd spiesViews: (int) spiesViews
                        chainBuilder: (int) cb chainResolver: (int) cr acceptingAt: (int) l;
-(NSDictionary*) singleTestWithKnights: (int) knights spies: (int) spies spiesViews: (int) spiesViews
                                 chainBuilder: (int) cb chainResolver: (int) cr acceptingAt: (int) l;
//the last method just allocated a crowd at random and then calls the first method (to set all views)

-(NSDictionary*) spiderTestWithCrowd: (Crowd*) crowd spiesViews: (int) spiesViews acceptingAt: (int) l;
-(NSDictionary*) spiderTestWithKnights: (int) knights spies: (int) spies
                            spiesViews: (int) spiesViews acceptingAt: (int) l;
//similar methods for spider interrogator

-(void) multipleTestsWithKnights: (int) knights spies: (int) spies spiesViews: (int) spiesViews N: (int) N
                    chainBuilder: (int) cb chainResolver: (int) cr acceptingAt: (int) l;
//These methods test only the given chainbuilder and chainresolver

-(void) multipleTestsWithKnights: (int) knights spies: (int) spies spiesViews: (int) spiesViews N: (int) N;
//Tests several chainbuilders and chainresolvers at once (note signature is a subset of last method)
-(void) multipleSpiderTestsFindingKnightWithKnights: (int) knights spies: (int) spies
										spiesViews: (int) spiesViews N: (int) N acceptingAt: (int) l;


-(void) multipleSpiderTestsWithKnights: (int) knights spies: (int) spies
                            spiesViews: (int) spiesViews N: (int) N acceptingAt: (int) l;

-(void) specialTest;
-(void)	findAverage: (int) L endAt: (int) M step: (int) k spiesViews: (int) spiesViews runs: (int) N
		chainBuilder: (int) cb chainResolver: (int) cr propSpies: (float) prop acceptingAtProp: (float) propAcc;



@end
