#import <Foundation/Foundation.h>
#import "Crowd.h";
#import "Interrogator.h";
#import "Tester.h"

#include "globalvariables.c"
//this should not be selected in the Project Builder interface (otherwise included twice, and
//the linker complains)


//use this with NSLogD to turn off reporting

int main (int argc, const char ** argv) {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    srand(time (0));
    const int N = 250; const int L = 300; const int M = 300; const int k = 50;
    const int knights = 51; const int spies = 49; const int spiesViews = RANDOM; const float prop = 0.5; 
	const float propAcc = 0.25; //DECIMALS! 
    const int l = spies; //threshhold for acceptance in spiderTest, and now in chain building strategies as well
	                     //but note that should be spies+1 for spiderTest, but just spies for cbs
    Tester *tester = [[Tester alloc] init];
	//NSLog(@"Tester inited");
    //[tester multipleTestsWithKnights: knights spies: spies spiesViews: spiesViews N: N];
    
	//[tester multipleTestsWithKnights: knights spies: spies spiesViews: spiesViews N: N
    //                    chainBuilder: MWCB chainResolver: JOINCR acceptingAt: l];
    
	//[tester singleTestWithKnights: knights spies: spies spiesViews: spiesViews
    //                 chainBuilder: MWCB chainResolver: JOINCR acceptingAt: l];
    
	//[tester spiderTestWithKnights: knights spies: spies spiesViews: spiesViews acceptingAt: l];
    //[tester multipleSpiderTestsWithKnights: knights spies: spies spiesViews: spiesViews N: N acceptingAt: l];
	
	[tester findAverage: L endAt: M step: k spiesViews: spiesViews runs: N
		    chainBuilder: MWCB chainResolver: JOINCR propSpies: prop acceptingAtProp: propAcc];
    //[tester multipleSpiderTestsFindingKnightWithKnights: (int) knights spies: (int) spies
	//									spiesViews: (int) spiesViews N: (int) N];
	//[tester paperTest];

	//[tester smallTest];
	//[tester crosslinkTest];
	//[pool release];
    return 0;
}

