//
//  ChainBuilderDW.h
//  KnightsAndSpies
//
//  Created by Mark Wildon on Tue Mar 27 2007.
//  Copyright (c) 2007 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "Crowd.h"
#import "TaggedChain.h"

@interface ChainBuilderDW : NSObject {
    NSMutableArray* weights;
    Crowd* crowd;
}
-(ChainBuilderDW*) initWithDW: (Crowd*) crowd; //clash if give method same name as Interrogator method ...
-(NSDictionary*) buildChains;
//returns allChains and finalKnight, and also allSpyChains and allKnightChains
-(NSDictionary*) buildChainsConsidering: (NSMutableArray*) peopleToConsider;
//returns spyChains and knightChains
-(NSMutableArray*) finalPeople: (NSMutableArray*) chains;
//returns all final people in chains, so call it with knightChains

//COMMENTED OUT AS WILL NOW USE CHAINJOINER FOR THIS
//-(NSMutableArray*) joinSpyChains: (NSMutableArray*) spyChains
//                  toKnightChains: (NSMutableArray*) knightChains;
//takes knight chains and spy chains and joins them up making TaggedChains so that a typical
//chain looks like K K ... K S (first K asked about second, second about third etc,
//until we reached a spy, or end at a K
//for our application it shd be enough to sort by length at the end
//we know that we can work forwards through each kind of chain and only
//join to the end of the chain in construction
@end

