//  ChainBuilderMW.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>
#import "Crowd.h"
#import "TaggedChain.h"
#import "ChainJoiner.h"

@interface ChainBuilderMW : NSObject {
    NSMutableArray* weights;
    Crowd* crowd;
	int l; //threshhold for acceptance
}
-(ChainBuilderMW*) initWithMW: (Crowd*) crowd acceptingAt: (int) l; //clash if give method same name as Interrogator method ...
-(NSDictionary*) buildChains;
//returns allChains and finalKnight
-(NSDictionary*) buildChainsConsidering: (NSMutableArray*) peopleToConsider;
    int compareLengthsOfTaggedChains (id first, id second, void* context);
-(NSMutableArray*) finalKnights: (NSMutableArray*) chains;
//only final knights of strictly positive weight are returned
@end
