//  ChainJoiner.m
//  KnightsAndSpies


#import "ChainJoiner.h"


@implementation ChainJoiner
-(ChainJoiner*) initWithAllChains: (NSMutableArray*) givenChains
{
    self = [super init];
    allChains = givenChains;
    return self;
}

-(NSMutableArray*) joinChains
{
    //modifies allChains and its elements 
    int n = [allChains count];
    int i; for (i=n-1;i>=0;i--) {
        NSMutableArray* currentChains = [allChains objectAtIndex: i];
        int j; for (j=0;j<[currentChains count];j++) {
            //NSMutableArray* newChain = [[NSMutableArray alloc] init];
            TaggedChain* end = [currentChains objectAtIndex: j];
            //NSLog(@"Considering chain %@",end);
            TaggedChain* newTaggedChain = [[TaggedChain alloc] init];
            [newTaggedChain setChain: [end chain]];
            NSMutableArray* newChain = [newTaggedChain chain];
            int first = [[newChain objectAtIndex: 0] intValue];
            //NSLog(@"First member = %i",first);
            int k; for (k=i-1;k>=0;k--) {
                NSMutableArray* candidateChains = [allChains objectAtIndex: k];
                int l; for (l=0;l<[candidateChains count];l++) {
                    TaggedChain* candidateTaggedChain = [candidateChains objectAtIndex: l];
                    //NSLog(@"trying to match with chain %@ which has last knight %i",candidateTaggedChain,
                          //[candidateTaggedChain lastKnight]);
                    if ([candidateTaggedChain lastKnight] == first) {
                        //NSLog(@"Found a match with %@",candidateTaggedChain);
                        //need to insert the knights from the candidateChain into newChain at the start
                        NSMutableArray* candidateChain = [candidateTaggedChain chain];
                        int length = [candidateChain count]
                            - (([candidateTaggedChain endsWithSpy]) ? 1 : 0) - 1;
                        //note last -1 because we don't want to include the person we already have
                        int m; for (m=0;m<length;m++) {
                            [newChain insertObject: [candidateChain objectAtIndex: m]
                                           atIndex: m];
                        }
                        first = [[newChain objectAtIndex: 0] intValue];
                    }
                }
                //finished iterating over candidateChains
            }
            //finished interating over allChains
            //at this point newChain is what it should be, modulo tags
            if ([end endsWithSpy])
                [newTaggedChain setEndsWithSpy: TRUE];
            else
                [newTaggedChain setEndsWithSpy: FALSE];
            [newTaggedChain setWeight: [end weight]];
            [currentChains replaceObjectAtIndex: j //i.e. the current TaggedChain we called end
                                     withObject: newTaggedChain];
        }
        //finished iterating over currentChains
    }
    //finished interating over allChains
    return allChains;
}

                            
            
        
        
        


@end
