//  Crowd.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>
// Need to know about possible members of crowds
#import "Person.h"
#import "Knight.h"
#import "Spy.h"

@interface Crowd : NSObject {
    int numberOfPeople;
    NSMutableArray* members;
}

-(int) numberOfPeople;
-(Person *) person: (int) i;
-(Crowd *) initWithGivenMembers: (NSMutableArray*) givenMembers;
-(Crowd *) initRandomlyWithKnights: (int) knights spies: (int) spies;
    //note still have to initialise the knights and spies views

-(void) setKnightsViews;
-(void) setSpiesViewsToTruth;
-(void) setSpiesViewsToAlwaysLie;
-(void) setSpiesViewsRandomly;
-(void) setSpiesViewsToAllKnights;
-(void) setSpiesViewsToAllSpies;
-(void) setSpiesViewsReversely;
-(void) setSpiesViewsToReverseOrSpy;

-(void) reset;
//sets questionsAsked to null for each person

-(void) showMembers;
-(void) showMembersFully;
-(void) showMembersAbbreviatedly;
-(NSMutableArray *) membersAsNumbers;

-(int) numberOfQuestionsAsked;

-(BOOL) testIfCorrectAnswer: (NSMutableArray*) answer;
-(BOOL) someoneAskedTwiceAboutSamePerson;

@end
