//
//  InterrogatorDW.m
//  KnightsAndSpies
//
//  Created by Mark Wildon on Tue Mar 27 2007.
//  Copyright (c) 2007 __MyCompanyName__. All rights reserved.
//

#import "InterrogatorDW.h"


@implementation InterrogatorDW

-(InterrogatorDW*) initWithCrowdDW: (Crowd*) givenCrowd
{
    self = [super init];
    crowd = givenCrowd; //Not copied
    //NSLog(@"initWithCrowd here, just set weights = %@",weights);
    //NSLog(@"crowd = %@",crowd);[crowd showMembers];
    return self;
}

-(NSMutableArray*) determineIdentitiesDW
{
    ChainBuilderDW* chainBuilderDW = [[ChainBuilderDW alloc] initWith: crowd];
    NSDictionary* results = [chainBuilderDW buildChains];

    //extract results
    NSMutableArray *knightChains = [results objectForKey: @"knightChains"];
    NSMutableArray *spyChains = [results objectForKey: @"spyChains"];
    NSMutableArray *joinedChains = [results objectForKey: @"joinedChains"];
    int finalKnight = [[results objectForKey: @"finalKnight"] intValue];
    Person *knight = [crowd person: finalKnight];

   
    if ([knight isSpy]) {
        NSLog(@"FINISHED AT SPY");
        [crowd showMembers];      //always working with REVERSE at moment   
        NSLog(@"finished at spy %i",finalKnight);
        NSLog(@"knightChains = %@",knightChains);
        NSLog(@"spyChains = %@",spyChains);
        NSLog(@"joinedChains = %@",joinedChains);
    }
    else {
        NSLog(@"finished at knight %i",finalKnight);
        NSLog(@"questions asked = %i",[crowd numberOfQuestionsAsked]);
        NSLog(@"joinedChains = %@",joinedChains);
        [crowd showMembers];
    }
    
    return knightChains;
}
@end
