//  Person.m
//  KnightsAndSpies

#import "Person.h"

@implementation Person
-(Person *) initWithNumber: (int) i; {
    self = [super init];
    views = [[NSMutableArray alloc] init];
    questionsAsked = [[NSMutableArray alloc] init];
    number = i;
    weight = 0;
    return self;
}

-(void) setViews: (NSMutableArray*) givenViews {
    views = givenViews; }

-(int) number {
    return number; }

//-(int) weight {
//    return weight; }
//
//-(void) setWeight: (int) w {
//    weight = w; }

-(NSNumber*) viewOnPerson: (int) i {
    [questionsAsked addObject: [NSNumber numberWithInt: i]];
    // note we don't bother recording the answer, since we can
    // assume that even a spies views are fixed
    return [views objectAtIndex: i];
}

-(NSMutableArray*) questionsAsked {
    return questionsAsked; }

-(int) numberOfQuestionsAsked {
    return [questionsAsked count]; }

-(void) showNumber {
    NSLog(@"person number %i",number); }

-(void) showViews {
    NSLog(@"views of person %@ are as follows: %@",self,views); }

-(BOOL) askedTwiceAboutSamePerson {
    //return TRUE if questionsAsked contains a duplicate, otherwise FALSE
    NSMutableArray* multiplicities = [[NSMutableArray alloc] init];
    int i; BOOL askedTwice = FALSE; //on the G4 Mac wasn't necessary to set this to false
    for (i=0;i<[views count];i++) {
        [multiplicities addObject: [NSNumber numberWithInt: 0]];
    }
    for (i=0;i<[questionsAsked count];i++) {
        int p = [[questionsAsked objectAtIndex: i] intValue];
        int old = [[multiplicities objectAtIndex: p] intValue];
        [multiplicities replaceObjectAtIndex: p
                                  withObject: [NSNumber numberWithInt: p+1]];
        if (old > 0) {
            askedTwice = TRUE;
            NSLog(@"asked Twice about person %i",p);
        }
    }
    return askedTwice;
}

-(void) showViewsAbbreviatedly {
    if ([questionsAsked count] == 0) {
        NSLog(@"person %@ hasn't been asked about anyone yet\n\n",self);
    }
    else {
        NSLog(@"person %@ has been asked about",self);
        int i; for (i=0;i<[questionsAsked count];i++) {
            int j = [[questionsAsked objectAtIndex: i] intValue];
            int k = [[views objectAtIndex: j] intValue];
            NSLog(@"%i, with answer %@",j, (k==KNIGHT) ? @"Knight" : @"Spy");
        }
        NSLog(@"");
       // NSLog(@"person %@ has been asked about these people: %@",self,questionsAsked);
        
    //    int i; for (i=0;i<[views count];i++) {
    //        //NSLog(@"i=%i",i);
    //        int j; for (j=0;j<[questionsAsked count];j++) {
    //            if ([[questionsAsked objectAtIndex: j] intValue] == i)
    //                NSLog(@"%i",i);
    //        }
    //    }
    }
}

-(void) showQuestionsAsked {
    NSLog(@"person %@ has been asked about: %@",self,questionsAsked); }

-(void) resetQuestionsAsked {
    [questionsAsked removeAllObjects];
}


//These methods are overridden in spy.m
//Setting them here means that the Knight subclass needs no implementation code of its own
-(BOOL) isKnight {
    return TRUE;
}

-(BOOL) isSpy {
    return FALSE;
}


@end
