//  Spider.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>

@interface Spider : NSObject {
    int person;
    NSMutableArray* votesFor;
    NSMutableArray* votesAgainst;
}

-(Spider*) initWithPerson: (int) givenPerson;
-(int) person;
-(NSMutableArray*) votesFor;
-(NSMutableArray*) votesAgainst;

-(void) addVoteFor: (int) givenPerson;
-(void) addVoteAgainst: (int) givenPerson;

@end
