//  Spider.m
//  KnightsAndSpies

#import "Spider.h"


@implementation Spider
-(Spider*) initWithPerson: (int) givenPerson
{
    self = [super init];
    votesFor = [[NSMutableArray alloc] init];
    votesAgainst = [[NSMutableArray alloc] init];
    person = givenPerson;
    return self;
}

-(int) person
{
    return person;
}

-(NSMutableArray*) votesFor
{
    return votesFor;
}

-(NSMutableArray*) votesAgainst
{
    return votesAgainst;
}

-(void) addVoteFor: (int) givenPerson
{
    [votesFor addObject: [NSNumber numberWithInt: givenPerson]];
}

-(void) addVoteAgainst: (int) givenPerson
{
    [votesAgainst addObject: [NSNumber numberWithInt: givenPerson]];
}

-(NSString*) description
{
    NSString* first = [NSString stringWithFormat: @"Person %i: votesFor\n",person];
    NSMutableString* desc = [first mutableCopy];
    [desc appendString: [votesFor description]];
    [desc appendString: @"votesAgainst\n"];
    [desc appendString: [votesAgainst description]];
    return desc;
}
@end
