//  SpiderInterrogator.h
//  KnightsAndSpies

#import <Foundation/Foundation.h>
#import "Crowd.h"
#import "Person.h"
#import "Spider.h"

@interface SpiderInterrogator : NSObject {
    Crowd* crowd;
}
-(SpiderInterrogator*) initWithCrowdSpider: (Crowd*) crowd; //multiple methods with same name problem
-(NSDictionary*) determineIdentitiesAcceptingAt: (int) l;
//l is the number of + votes needed at accept someone as a knight; e.g. if its known there
//are at most 3 spies then l=4 (since if someone has 4 votes for, must be a knight, with
//3 votes for could be a spy, as this counts one vote automatically given by someone to themselves)
@end
