//  Spy.m
//  KnightsAndSpies

#import "Spy.h"

@implementation Spy

-(BOOL) isKnight {
    return FALSE; }

-(BOOL) isSpy {
    return TRUE; }

-(void) setViewsRandomlyWithCrowdSize: (int) n {
    [views removeAllObjects];
    int i; for (i=0;i<n;i++) {
        [views addObject: [NSNumber numberWithInt: rand() % 2]];
    }
}

-(void) setViewsToAllKnightsWithCrowdSize: (int) n {
    //NSLog(@"setViewsToAllKnightsWithCrowdSize: %i here",n);
    [views removeAllObjects];
    int i; for (i=0;i<n;i++) {
        [views addObject: [NSNumber numberWithInt: KNIGHT]];
    }
    //NSLog(@"set views to all Knights, here they are %@",views);
}

-(void) setViewsToAllSpiesWithCrowdSize: (int) n {
    [views removeAllObjects];
    int i; for (i=0;i<n;i++) {
        [views addObject: [NSNumber numberWithInt: SPY]];
    }
}

-(void) setViewsToAlwaysLie: (NSMutableArray*) trueSituation {
    [views removeAllObjects];
    int i; for (i=0;i<[views count];i++) {
        [views addObject:
            ([trueSituation objectAtIndex: i] == [NSNumber numberWithInt: KNIGHT]) ?
            [NSNumber numberWithInt: SPY] :
            [NSNumber numberWithInt: KNIGHT]];
    }
}

@end
