//  TaggedChain.h
//  KnightsAndSpies


#import <Foundation/Foundation.h>


@interface TaggedChain : NSObject {
    NSMutableArray* chain;
    BOOL endsWithSpy;
    int weight;
    int firstKnight; //by default, firstKnight is set to -1, updated by chainresolving machinery
}

-(NSMutableArray*) chain;
-(void) setChain: (NSMutableArray*) givenChain;

-(BOOL) endsWithSpy;
-(void) setEndsWithSpy: (BOOL) flag;

-(int) firstKnight;
-(void) setFirstKnight: (int) x;

-(int) lastKnight;

-(int) weight;
-(void) setWeight: (int) w;

@end
