//  TaggedChain.m
//  KnightsAndSpies

#import "TaggedChain.h"


@implementation TaggedChain

-(TaggedChain*) init
{
    [super init];
    chain = [[NSMutableArray alloc] init];
    endsWithSpy = FALSE;
    weight = 0; firstKnight = -1;
    return self;
}

-(NSMutableArray*) chain
{
    return chain;
}

-(void) setChain: (NSMutableArray*) givenChain
{
    chain = givenChain;
}

-(BOOL) endsWithSpy
{
    return endsWithSpy;
}

-(void) setEndsWithSpy: (BOOL) flag;
{
    endsWithSpy = flag;
}

-(int) weight
{
    return weight;
}

-(void) setWeight: (int) w
{
    weight = w;
}

-(int) firstKnight
{
    return firstKnight;
}

-(int) lastKnight
{
    if ([self endsWithSpy])
        return [[chain objectAtIndex: [chain count]-2] intValue];
    else
        return [[chain lastObject] intValue];
}
            
-(void) setFirstKnight: (int) x
{
    firstKnight = x;
}

-(NSString*) description
{
    NSString* first = [chain description];
    NSMutableString* desc = [first mutableCopy];
    [desc appendString: (endsWithSpy) ? @" spy" : @" knight"];
    NSString* weightStr = [NSString stringWithFormat: @" weight %i",weight];
    [desc appendString: weightStr];
    NSString* knightStr = [NSString stringWithFormat: @" firstKnight %i",firstKnight];
    [desc appendString: knightStr];
    return desc;
}

@end
