// variables declared outside any function are automatically const, global
// import using extern int declaration in other files
// global variable declarations for spies/knights
int SPY = 0;
int KNIGHT = 1;

// for testing functions: which sort of crowd to build (use KNIGHT, SPY also)
int RANDOM = -1;
int REVERSE = -2;
int TRUTH = -3;
int REVERSEORSPY = -4;

// and which strategy to use
int DWCB = 1;       //buid chains according to DW strategy
int MWCB = 2;       //build chains according to MW strategy

int NAIVECR = 1;    //resolve chains looking at first array only
//so e.g. two chains linked K K K S, S S S K would take 5 questions
//or two linked DW chains K K, S S would take 3 questions
int ALLCR = 2;    //resolve chains working back from last array
//chains above would take 2 + 2 + 2 = 6 questions, the DW would take 2
int LONGCR = 3;   //resolve MW chains working back from last array
//but ignoring knight chains of length 3 or less
int JOINCR = 4;   //resolve MW chains by joining them up and then
//working backwards through arrays